// ChatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "afxctl.h"
#include <string>

#include "Chat.h"
#include "ChatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int ID_TIMER1 = 100;
CChatDlg* self = NULL;

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CChatDlg dialog

CChatDlg::CChatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChatDlg)
	m_Ready = FALSE;
	m_Host = _T("");
	m_Inbox = _T("");
	m_Outbox = _T("");
	m_Server = _T("");
	m_Client = _T("");
	m_Recording = FALSE;
	m_Playback = FALSE;
	m_SizeIn = _T("");
	m_SizeOut = _T("");
	m_PortStr = _T("");
	m_FileName = _T("");
	m_SaveToFile = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatDlg)
	DDX_Control(pDX, IDC_EDIT4, m_Port);
	DDX_Control(pDX, IDC_COMBO3, m_Protocol);
	DDX_Control(pDX, IDC_COMBO1, m_Device);
	DDX_Control(pDX, IDC_EDIT2, m_EditInbox);
	DDX_Control(pDX, IDC_BUTTON1, m_Connect);
	DDX_Check(pDX, IDC_CHECK1, m_Ready);
	DDX_Text(pDX, IDC_EDIT1, m_Host);
	DDX_Text(pDX, IDC_EDIT2, m_Inbox);
	DDX_Text(pDX, IDC_EDIT3, m_Outbox);
	DDX_Text(pDX, IDC_STATIC1, m_Server);
	DDX_Text(pDX, IDC_STATIC2, m_Client);
	DDX_Check(pDX, IDC_CHECK2, m_Recording);
	DDX_Check(pDX, IDC_CHECK3, m_Playback);
	DDX_Text(pDX, IDC_STATIC3, m_SizeIn);
	DDX_Text(pDX, IDC_STATIC4, m_SizeOut);
	DDX_Text(pDX, IDC_EDIT4, m_PortStr);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_Check(pDX, IDC_SAVETOFILE, m_SaveToFile);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChatDlg, CDialog)
	//{{AFX_MSG_MAP(CChatDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_EN_CHANGE(IDC_EDIT3, OnChangeEdit3)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_SAVETOFILE, OnSaveToFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatDlg message handlers

BOOL CChatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	self = this;

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_Ready			= true;
	m_Recording		= true;
	m_Playback		= true;
	m_SaveToFile	= false;

	m_Host			= _T("192.168.1.1");
	m_Inbox			= "";
	m_Outbox			= _T("[write your message here]");
	m_Server			= "";
	m_Client			= "";
	m_SizeIn			= "";
	m_SizeOut		= "";
	m_FileName		= _T("C:\\Temp\\conversation.wav");

	UpdateData(FALSE);
	VCInit();
	m_Gate->FormatTag = 49; // GSM codec
	m_Gate->PcmBitsPerSample = 16;
	m_Gate->PcmSamplesPerSec = 8000;
	m_Gate->PcmNumChannels = 1; // mono

	for (int i = 0; i < m_WaveIn->GetDeviceCount(); i++)
		m_Device.AddString(m_WaveIn->GetDeviceName(i));
	m_Device.SetCurSel(0);

	m_Protocol.AddString(_T("TCP"));
	m_Protocol.AddString(_T("UDP"));
	m_Protocol.SetCurSel(1);

	m_Port.SetWindowText(_T("17820"));

	SetTimer(ID_TIMER1, 500, NULL);
	
	OnCheck1();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChatDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChatDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CChatDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer(ID_TIMER1);
	VCUninit();	
	CDialog::OnClose();
}

void CChatDlg::ConfigureGate()
{
	m_Gate->DeviceId = m_Device.GetCurSel();
	m_Gate->Proto = static_cast<unaProtoType>(m_Protocol.GetCurSel());

	BSTR port = m_PortStr.AllocSysString();
	m_Gate->Port = port;
	SysFreeString(port);
}

void CChatDlg::VCInit()
{
	m_Gate.CreateInstanceLic(__uuidof(vcproMediaGateX), L"0");
	m_WaveIn.CreateInstanceLic(__uuidof(vcproWaveInDeviceX), L"0");

	m_GateSink.m_DialogHWND = m_hWnd;

	m_pUnkSink = m_GateSink.GetIDispatch(FALSE);
	BOOL res = AfxConnectionAdvise(m_Gate, IID_IMediaGateEventSink, m_pUnkSink, FALSE,
		&m_dwCookie);

	CWnd* pWnd = GetDlgItem(IDC_EDIT3);
	pWnd->EnableWindow(false);
}

void CChatDlg::VCUninit()
{
	m_Gate->Active = false;
	AfxConnectionUnadvise(m_Gate, IID_IMediaGateEventSink, m_pUnkSink, FALSE,
		m_dwCookie);
}

void CChatDlg::OnTimer(UINT nIDEvent) 
{
	CWnd* pWnd;

	pWnd = GetDlgItem(IDC_BUTTON5);
	pWnd->EnableWindow((!m_Gate->Active) && (!m_Gate->IsClientActive));

	pWnd = GetDlgItem(IDC_BUTTON1);
	pWnd->EnableWindow(!m_Gate->IsClientActive);
	pWnd = GetDlgItem(IDC_BUTTON4);
	pWnd->EnableWindow(m_Gate->IsClientActive);

	pWnd = GetDlgItem(IDC_EDIT3);
	pWnd->EnableWindow(m_Gate->IsClientActive ||
		(m_Gate->IsServerActive && (m_Gate->ClientCount > 0)));

	pWnd = GetDlgItem(IDC_STATIC1);
	if (m_Gate->IsServerActive) pWnd->SetWindowText(_T("server: active"));
	else pWnd->SetWindowText(_T("server: inactive"));

	pWnd = GetDlgItem(IDC_STATIC2);
	if (m_Gate->IsClientActive) pWnd->SetWindowText(_T("client: active"));
	else pWnd->SetWindowText(_T("client: inactive"));

	char buffer[10];
	itoa(m_Gate->BytesReceived, buffer, 10);
	string sizeIn(string("bytes received: ") + string(buffer));
	itoa(m_Gate->BytesSent, buffer, 10);
	string sizeOut(string("bytes sent: ") + string(buffer));

	pWnd = GetDlgItem(IDC_STATIC3);
	pWnd->SetWindowText(sizeIn.c_str());
	pWnd = GetDlgItem(IDC_STATIC4);
	pWnd->SetWindowText(sizeOut.c_str());

	CDialog::OnTimer(nIDEvent);
}

void CChatDlg::OnButton1() 
{
	UpdateData();
	ConfigureGate();
	BSTR host = m_Host.AllocSysString();
	m_Gate->Connect(host);
	SysFreeString(host);
}

void CChatDlg::OnButton4() 
{
	m_Gate->Disconnect();	
}

void CChatDlg::OnCheck1() 
{
	UpdateData();
	if (m_Ready) ConfigureGate();
	m_Gate->Active = m_Ready;
}

//

BEGIN_DISPATCH_MAP(CMediaGateEventSink, CCmdTarget)
//{{AFX_DISPATCH_MAP(CMediaGateEventSink)
	DISP_FUNCTION_ID(CMediaGateEventSink, "OnReceiveText", 201, OnReceiveText, VT_EMPTY, VTS_I4 VTS_BSTR)
//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CMediaGateEventSink, CCmdTarget)
	INTERFACE_PART(CMediaGateEventSink, IID_IMediaGateEventSink, Dispatch)
END_INTERFACE_MAP()

CMediaGateEventSink::CMediaGateEventSink()
{
	EnableAutomation();
}

void CMediaGateEventSink::OnReceiveText(long ConnId, BSTR text)
{
	char* msg = (char*) text;

	/*
	USES_CONVERSION;
	const char* asciiText = W2A(text);
	*/

	HWND pWnd = GetDlgItem(m_DialogHWND, IDC_EDIT2);
	LockWindowUpdate(pWnd);
	BOOL res = SetWindowText(pWnd, msg);
	int len = strlen(msg);
	self->m_EditInbox.SetSel(len, len);
	LockWindowUpdate(NULL);
}

void CChatDlg::OnChangeEdit3() 
{
	CWnd* pWnd = GetDlgItem(IDC_EDIT3);
	int len = pWnd->GetWindowTextLength();
	char* buffer = new char[len + 1];
	pWnd->GetWindowText(buffer, len + 1);

	_bstr_t str(buffer);
	m_Gate->SendText(0, str);

	delete buffer;
}

void CChatDlg::OnCheck2() 
{
	UpdateData();
	m_Gate->EnableRecording = m_Recording;
}

void CChatDlg::OnCheck3() 
{
	UpdateData();
	m_Gate->EnablePlayback = m_Playback;
}

void CChatDlg::OnButton2() 
{
	char buffer[5];
	itoa(m_WaveIn->GetMixerId(m_Device.GetCurSel(), true), buffer, 10);
	string params = "/r /d" + string(buffer);
	ShellExecute(NULL, "open", "sndvol32", params.c_str(), NULL, SW_SHOW);
}

void CChatDlg::OnButton3() 
{
	char buffer[5];
	itoa(m_WaveIn->GetMixerId(m_Device.GetCurSel(), false), buffer, 10);
	string params = "/p /d" + string(buffer);
	ShellExecute(NULL, "open", "sndvol32", params.c_str(), NULL, SW_SHOW);
}

void CChatDlg::OnButton5() 
{
	m_Gate->FormatChoose("Sound quality", reinterpret_cast<long>(m_hWnd));	
}

void CChatDlg::OnSaveToFile() 
{
	UpdateData();

	CWnd* pWnd = GetDlgItem(IDC_FILENAME);
	int len = pWnd->GetWindowTextLength();
	char* buffer = new char[len + 1];
	pWnd->GetWindowText(buffer, len + 1);

	_bstr_t str(buffer);

	m_Gate->ConversationFileName		= buffer;
	m_Gate->ConversationSaveToFile	= m_SaveToFile;

	delete buffer;
}
